Subject: Re: [PATCH] nohz: prevent tilegx network driver interrupts

From: Chris Metcalf <[email-masked]>
Date: Mon, 20 Jul 2015 18:15:44 -0400

On 07/20/2015 05:49 PM, Frederic Weisbecker wrote:
> On Mon, Jul 20, 2015 at 05:22:12PM -0400, Chris Metcalf wrote:
>> On 07/11/2015 10:30 AM, Frederic Weisbecker wrote:
>>> On Fri, Jul 10, 2015 at 03:05:02PM -0400, Chris Metcalf wrote:
>>>> The tilegx chips typically don't do cpu offlining anyway, since
>>>> we've never really found a usecase, so whatever you boot with
>>>> you always have available.  We do have support for a bare-metal
>>>> mode which you can run on some of the cores, so you may start
>>>> with fewer than cpu_possible actually running, but it will always
>>>> be that same set of cores.
>>> And that bare metal mode runs out of Linux?
>> The bare metal environment runs on cpus that have been marked
>> as unavailable to Linux, so Linux just sees them as permanently
>> offlined.  There is a BME driver (which we haven't upstreamed,
>> since the BME isn't upstreamed either) that arranges to share
>> memory between the BME and Linux.
>>
>> I don't think that many customers are using the BME in any
>> case.  We push all of them towards using our dataplane mode
>> instead, since it almost always works just as well from a
>> performance perspective, and is easier to develop code for.
> So bare metal mode is different than dataplane mode, right?
> Where bare metal mode offlines the CPU and IIUC dataplane mode
> instead uses CPUs that are available to Linux, just isolated
> with nohz and various affinity stuff, right?

Yes, exactly.  Cores running the bare metal environment are
NOT running Linux at all, just talking directly to the Tilera
hypervisor.

-- 
Chris Metcalf, EZChip Semiconductor
http://www.ezchip.com